//Multipaint 18.10.2018
//Multipaint 2018b
//Tero Heikkinen (Dr. TerrorZ)

//processing setup() draw() things here

//force set machine at beginning of setup()

PrintWriter exwriter;
int debugger=-1;
int machine;

final int COMMAND=157; // Marq's cmd/ctrl solution

int g_active,g_tooltrigger,g_prevtool;
int g_rband,g_rbang,g_boxreconstruct,g_sorsaa,g_charlimit;
int g_animx,g_animy,g_animframes,g_animno,g_animtime,g_animspeed;
int g_omag,g_bordh,g_bordv,g_keymacpos,g_framec;

String g_keymacro="";

int[] g_r = new int[266];int[] g_g = new int[266];int[] g_b = new int[266];
int[] g_rgb = new int[266];

byte[] g_map = new byte[88000];
byte[] g_fillmap = new byte[88000];
byte[] g_rmap = new byte[88000];
byte[] g_icons = new byte[88000];
byte[] g_brush = new byte[88000];
byte[] g_template = new byte[16384];
byte[] g_redo = new byte[1024];
byte[] g_remdo = new byte[1024];
int[] g_chaup = new int[64];
byte[] g_data = new byte[1024];
int [] g_magpix = new int[256];int [] g_magpiy = new int[256];

byte g_realfront,g_realback;
PImage output,outputsans;
String g_name;

//dimensions
int X,Y,MX,MY;
//generic mouse
int g_ofx,g_ofy,g_button,g_realbutton,g_klikkeri,g_mx,g_my,g_orx,g_ory,g_msx,g_msy;
//rubberband,mouse
int g_phase,g_rx,g_ry,g_rx2,g_ry2,g_rubbermode;
int g_prex,g_prey,g_storedcoordx,g_storedcoordy;
//window positioning
int g_windowx,g_windowy,g_maglocx,g_maglocy;
int g_hedge,g_vedge,g_uizoom,g_wzoom;
//icons & gui stuff
int g_iconx,g_icony,g_piconx,g_picony,g_iconmode;
int g_gridx,g_gridy,g_spare;
int g_farge,g_backg,g_ofarge,g_repanel,g_msgctr;
//machine related color properties
int g_attrimode,g_britemode,g_multic,g_backmode,g_maxcolors,g_hzoomer;
float g_palsteps;
//brush, tool parameters
int g_bsourcex,g_bsourcey,g_bsourcex2,g_bsourcey2;
int g_bsize,g_btype;


void setup()
{
  int i,x,y;
  
  machine=-1; //-1 for selector

  // for experimental or incomplete modes (without proper export)
  // try machine=AMIGA or PICO8,BK0010,COCO3,QLLOW,C64NOLIMIT,TIMEX
  
  g_uizoom=2;g_animspeed=1;
  //normi
  g_magpix[0]=3;g_magpix[1]=8;g_magpix[2]=16;
  g_magpiy[0]=3;g_magpiy[1]=8;g_magpiy[2]=16;
  //mini
  g_magpix[10]=2;g_magpix[11]=6;g_magpix[12]=16;
  g_magpiy[10]=2;g_magpiy[11]=6;g_magpiy[12]=16;
  //maxi
  g_magpix[20]=4;g_magpix[21]=16;g_magpix[22]=32;
  g_magpiy[20]=4;g_magpiy[21]=16;g_magpiy[22]=32;
  
  //FLAT normi
  g_magpix[100]=3;g_magpix[101]=9;g_magpix[102]=12;
  g_magpiy[100]=2;g_magpiy[101]=6;g_magpiy[102]=8;
  //FLAT mini
  g_magpix[110]=3;g_magpix[111]=9;g_magpix[112]=12;
  g_magpiy[110]=2;g_magpiy[111]=6;g_magpiy[112]=8;
  //FLAT maxi
  g_magpix[120]=6;g_magpix[121]=12;g_magpix[122]=21;
  g_magpiy[120]=4;g_magpiy[121]=8;g_magpiy[122]=14;  

  g_omag=1;g_bordh=64;g_bordv=32;
  
  pref_loader();
  
  if(machine==-1){
    if(gui)
    {
        try{ UIManager.setLookAndFeel("javax.swing.plaf.metal.MetalLookAndFeel"); }
        catch (Exception e) {};
        machine=selector("Select a Platform","C64 hires,C64 multicolor,ZX Spectrum,MSX1 mode 2,Plus4 hires,Plus4 multicolor,Amstrad CPC mode 0");
    }
    switch(machine)
    {
        case 0: machine=C64; break;
        case 1: machine=C64M; break;
        case 2: machine=SPECTRUM; break;
        case 3: machine=MSX; break;
        case 4: machine=PLUS4; break;
        case 5: machine=PLUS4M; break;
        case 6: machine=CPC; break;
        default: ;
    }
  }

  int yfix=0;
  if(g_inhibit_aspect==1){
    if(machine==QLLOW||machine==BK0010)Y=256;
    if(Y>200)yfix=Y-200;
  }
  
  if(g_uizoom>=1&&g_uizoom<=3)g_wzoom=g_uizoom+1;
 
  g_hedge=32*g_uizoom;
  g_vedge=32*g_uizoom;
  
  g_spare=0;
  g_bsize=0;
  g_btype=0;
  g_phase=0;
  g_button=LEFT;
  g_data['f']=1;// fill on
  g_data['g']=1;// grid on
  
  icon_loader();
  
  set_tool(3);
 
  g_gridx=8;g_gridy=8;
  g_multic=0;
  g_repanel=-2;
  
  //UI colors
  
  makecolor(256,0xff,0,0xff);makecolor(257,180,180,180);g_rgb[257]=0xff808080;
  makecolor(258,0,0,0);makecolor(259,48,48,48);
  
  //R,G and B for the palette sliders
  
  makecolor(260,255,0,0);makecolor(261,0,255,0);makecolor(262,0,0,255);
  makecolor(263,48,48,48);//backest UI background
  
  set_machine(machine);
 
  g_data['m']=0;g_data['M']=0; // mags off
  
  int truwinsizex=X*g_magpix[magmode()];
  int truwinsizey=Y*g_magpiy[magmode()];
  // println(magmode());
  // println(g_magpiy[magmode()]);
  if(g_forcedpalette.length()>3)act_loader(g_forcedpalette);
 
  if(g_forcex==0||g_forcey==0){
    g_hadjust=0;g_vadjust=0;
    int hsize=truwinsizex+g_hedge+(22)*g_wzoom;
    int vsize=truwinsizey+g_vedge+(14)*g_wzoom;
    while(vsize-g_vedge<(12*16)*g_wzoom){
      vsize=vsize+2;
    }
    while(hsize-g_hedge<(17*16)*g_wzoom){
      hsize=hsize+2;
    }    
    // println(vsize);
    size(hsize,vsize);
  }
  
  if(g_forcex>800 && g_forcey>600){
    size(g_forcex,g_forcey);
  }
    
  if(g_inhibit_aspect==1)g_aspect=SQUARERATIO;
  
  int paspect=g_wzoom;
  
  if(g_aspect==FLATRATIO)
  {
    if(g_wzoom==2)paspect=1;
    if(g_wzoom==3)paspect=2;
    if(g_wzoom==4)paspect=3;    
  }
  
  g_windowx=width-(g_hedge)-(truwinsizex);g_windowx=g_windowx/2;
  g_windowy=height-(g_vedge)-(truwinsizey);g_windowy=g_windowy/2; 
  if(g_hadjust>0)g_windowx=width-(g_hedge)-(g_wzoom*X)-g_hadjust;
  if(g_vadjust>0)g_windowy=height-(g_vedge)-(paspect*Y)-g_vadjust;
  
  switcher(3);
  
  g_map[4]=byte(g_maxcolors-1);
  g_ofarge=g_farge;
  MX=X/8;
  MY=Y/8;
  g_realfront=byte(g_farge);
  g_realback=byte(g_backg);
  
  output= createImage (X*g_omag+g_bordh*g_omag,Y*g_omag+g_bordv*g_omag,RGB);
  outputsans= createImage (X*g_omag,Y*g_omag,RGB);
  
  for(y=0;y<Y;y++){
   for(x=0;x<X;x++){
     absolute_clearpoint(x,y);
   }
  }

  switcher(2);
  noStroke();
  background(g_r[263],g_g[263],g_b[263]);
  sussborder();
  setup_raster();
  message("Multipaint|   2018b||v18.10.2018");
  message("*");
}


void draw()
{
  int msx,msy;

  if(!focused){
    g_control=false;
    g_shift=false; 
    delay(200);
  }
  if(g_data['n']==1){
      g_animtime++;
      if(g_animtime>8-g_animspeed*2){
        animbrush_do();
        g_animtime=0;  
    }
  }
  
  if(moicon(16*16*g_uizoom,height-32*g_uizoom,16*g_uizoom,24*g_uizoom))help('<');
  if(moicon(16*16*g_uizoom,height-8*g_uizoom,16*g_uizoom,8*g_uizoom))help('>');
  if(moicon(0,height-32*g_uizoom,15*16*g_uizoom,32*g_uizoom))help(TAB);
  if(moicon(width-32*g_uizoom,0,32*g_uizoom,16*g_uizoom))help('.');
  
  if(g_data['m']==0&&g_data['M']==0){
    msx=mouseX-g_windowx;
    msy=mouseY-g_windowy;
    msx=g_msx-g_windowx;msy=g_msy-g_windowy;
  }
  else
  {
    msx=mouseX;msy=mouseY;
  }
  g_mx=msx;g_my=msy;
 
 //actual tool drawing
  if(g_tooltrigger==1){ // comes from mousepressed, or mousedragged
    if(g_mx<=width-g_hedge&&g_my<=height-g_vedge)do_tool(msx,msy,g_button);
  }    
  g_msx=mouseX;g_msy=mouseY;   
  switcher(0);

  for(int i=0;i<1024;i++){
    g_remdo[i]=0;
  }
  
  int rememberbutton=g_button;
  
  //tool drawing for shows
  
  if(tool()!=5){
     if(g_phase==0)g_button=LEFT;
     do_tool(msx,msy,LEFT);
  }
  if(tool()==5){
    storecoords(msx,msy);
  }
  if(tool()==6)doline(g_rx,g_ry,g_rx2,g_ry2,0);
  if(tool()==7)docircle(g_rx,g_ry,g_rx2,g_ry2);
  if(tool()==8)rectangle(g_rx,g_ry,g_rx2,g_ry2);
  g_button=rememberbutton; 
  
  loadPixels();
  
    viewport();
    switcher(1);
    
    if(g_pgrab==1)preview_box_drag();
        
    preview_window();
    update_ui(false);
  
  updatePixels();
  
  if(g_msgctr>0)g_msgctr--;
    
  if(gui)gui_stuff();

  g_framec++;if(g_framec>1)g_framec=0;
  
  if(g_keymacro.length()>g_keymacpos){
      macro_command(g_keymacro.charAt(g_keymacpos));
      g_keymacpos++;
  }
}

